/*
 "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
 Copyright (C) 2001-2003 phonohawkput

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package aya;
import aya.*;
import java.io.*;
import java.util.*;
import java.util.regex.*;

// #defineや#globaldefineの処理。
// 行の結合もここで行なう。

public class Preprocessor
{
	protected static Hashtable global; // {検索文字列 => 置換文字列}
	static {
		global = new Hashtable();
	}
	
	BufferedReader br;
	Hashtable local; // {検索文字列 => 置換文字列}

	public Preprocessor(BufferedReader br)
	{
		this.br = br;
		this.local = new Hashtable();
	}
	
	public String doIt() throws Exception
	{
		StringBuffer result = new StringBuffer();
	
		Pattern define = Pattern.compile("^\\s*#define\\s+(.+?)\\s+(.+?)\\s*$");
		Pattern globaldefine = Pattern.compile("^\\s*#globaldefine\\s+(.+?)\\s+(.+?)\\s*$");
	
		while (true) {
			String line = br.readLine();
			if (line == null) {
				break;
			}
			
			Matcher matcher;
			if ((matcher = define.matcher(line)).find()) {
				local.put(matcher.group(1),matcher.group(2));
			}
			else if ((matcher = globaldefine.matcher(line)).find()) {
				global.put(matcher.group(1),matcher.group(2));
			}
			else {
				StringBuffer buf = new StringBuffer(line);
				
				Hashtable[] tables = new Hashtable[] {local,global};
				for (int i = 0; i < tables.length; i++) {
					for (Enumeration keys = tables[i].keys(); keys.hasMoreElements(); ) {
						String key = (String)keys.nextElement();
						String value = (String)tables[i].get(key);
						
						while (true) {
							int idx = buf.indexOf(key);
							if (idx == -1) {
								break;
							}
							else {
								buf.replace(idx,idx + key.length(),value);
							}
						}
					}
				}
				
				result.append(buf.toString()).append('\n');
			}
		}
		
		return result.toString();
	}
}
