/*
 "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
 Copyright (C) 2001-2003 phonohawk

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package aya.node;
import aya.*;
import aya.node.*;
import aya.eval.*;
import java.util.*;

public class Block
{
	Aya aya;
	String option;
	Vector statements; // [Statement,Statement,...]
	
	public Block(Aya aya)
	{
		this.aya = aya;
		this.option = null;
		this.statements = new Vector();
	}
	
	public Block setOption(String o) {
		if (o != null) {
			if (o.equals("nonoverlap") || o.equals("sequential")) {
				option = o;
			}
			else {
				try {
					throw new Exception("Option of block \""+o+"\" is not supported.");
				}
				catch (Exception e) {}
			}
		}
		return this;
	}
	
	public String getOption() {
		return option;
	}
	
	public Vector getStatements() {
		return statements;
	}
	
	public Block add(Statement s) {
		statements.add(s);
		return this;
	}
	
	/*
		ubN]ɂ͎l̕@܂B
		Ȃ킿Aʏ]Anonoverlap]Asequential]Aswitch]łB
	*/
	
	public Value eval(Namespace ns) throws Exception {
		// evalnullԂꍇB
		return eval(ns,-1);
	}
	public Value eval(Namespace ns,int switch_index) throws Exception {
		Vector resultgroups = new Vector(); // [Vector,...]
		
		Vector currentgroup = new Vector(); // [Value,...]
		resultgroups.add(currentgroup);
		
		for (int i = 0; i < statements.size(); i++) {
			Statement statement = (Statement)statements.elementAt(i);
			
			if (statement.isSeparator()) {
				// o͊mqB
				// ̃O[vIB̃O[vցB
				currentgroup = new Vector();
				resultgroups.add(currentgroup);
			}
			else if (statement.isBreak()) {
				throw statement.newBreakOccurrence();
			}
			else if (statement.isContinue()) {
				throw statement.newContinueOccurrence();
			}
			else if (statement.isReturn()) {
				// ŏIB
				return constructResult(resultgroups,switch_index);
			}
			else {
				Object result = statement.eval(ns);
				if (result != null) {
					if (result instanceof Value) {
						currentgroup.add(result);
					}
					else if (result instanceof Vector) {
						currentgroup.addAll((Vector)result);
					}
					else {
						throw new Exception("Internal Error: Statement#eval() returned object of "+result.getClass().getName()+" illegally.");
					}
				}
			}
		}
		return constructResult(resultgroups,switch_index);
	}
	protected Value constructResult(Vector resultgroups,int switch_index) throws Exception {
		if (option == null) {
			Value result = null;
			
			for (int i = 0; i < resultgroups.size(); i++) {
				Vector group = (Vector)resultgroups.elementAt(i);
				Value val_of_group = null;
				
				if (switch_index >= 0) {
					if (switch_index < group.size()) {
						val_of_group = (Value)group.elementAt(switch_index);
					}
					else {
						val_of_group = new Value("");
					}
				}
				else {
					if (group.size() > 0) {
						int idx = (int)(Math.random() * Integer.MAX_VALUE) % group.size();
						val_of_group = (Value)group.elementAt(idx);
					}
				}
				
				if (val_of_group != null) {
					if (result == null) {
						result = val_of_group;
					}
					else {
						result.setString(result.getString() + val_of_group.getString());
					}
				}
			}
			
			return result;
		}
		else {
			if (option.equals("nonoverlap")) {
				return null; // ܂
			}
			else if (option.equals("sequential")) {
				return null; // ܂
			}
			else {
				throw new Exception("Block option '"+option+"' is not supported.");
			}
		}
	}
}
