/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCBalloonScrollArrow extends NSView
{
	public static final float SCROLL_STEP = 10f;
	public static final int DEFAULT_WIDTH = 15;
	public static final int DEFAULT_HEIGHT = 15;
	
	SCSafetyBalloonController controller;
	NSClipView target;
	int type; // SCBalloonSkinServer.ARROW_UP or SCBalloonSkinServer.ARROW_DOWN
	NSImage image;
	NSColor bg_color,arrow_color; // image == null̎ɗLB
	//SCBalloonScrollerThread scroller_thread;
	NSTimer scroll_timer;
	boolean isVisible = false;
	
	public SCBalloonScrollArrow(SCSafetyBalloonController controller,int type)
	{
		// ftHgB摜gȂB
		super(new NSRect(0,0,DEFAULT_WIDTH,DEFAULT_HEIGHT));
		
		this.controller = controller;
		this.target = controller.getTextScrollView().contentView();
		this.type = type;
		this.image = null;
		this.bg_color = NSColor.colorWithCalibratedRGB(0.5f,0.5f,0.5f,0.8f);
		this.arrow_color = NSColor.colorWithCalibratedRGB(1.0f,1.0f,1.0f,0.8f);
	}
	
	public void cleanUp()
	{
		controller = null;
	}
	
	public void setImage(NSImage image)
	{
		// imagenullłǂB摜̎gp𒆎~B
		this.image = image;
		
		if (image == null)
			setBounds(new NSRect(0,0,DEFAULT_WIDTH,DEFAULT_HEIGHT));
		else
			setBounds(new NSRect(0,0,image.size().width(),image.size().height()));
	}
	
	private NSRect[] rectlist_bounds = null;
	public void drawRect(NSRect r)
	{
		if (!isVisible) return;
		
		if (image == null)
		{
			if (rectlist_bounds == null)
				rectlist_bounds = new NSRect[] {bounds()};
			
			bg_color.set();
			NSGraphics.fillRectList(rectlist_bounds);
			
			arrow_color.set();
			if (type == SCBalloonSkinServer.ARROW_UP)
			{
				NSPoint arrowCapPoint = new NSPoint(width() / 2f,height()-1);
				NSBezierPath.strokeLineFromPoint(
								new NSPoint(width() / 2f,1),
								arrowCapPoint); // |
				NSBezierPath.strokeLineFromPoint(
								new NSPoint(width() / 3f,height() / 2f),
								arrowCapPoint); // /
				NSBezierPath.strokeLineFromPoint(
								new NSPoint(width() * (2f / 3f),height() / 2f),
								arrowCapPoint); // \
			}
			else
			{
				NSPoint arrowCapPoint = new NSPoint(width() / 2f,1);
				NSBezierPath.strokeLineFromPoint(
								new NSPoint(width() / 2f,height()-1),
								arrowCapPoint); // |
				NSBezierPath.strokeLineFromPoint(
								new NSPoint(width() / 3f,height() / 2f),
								arrowCapPoint); // \
				NSBezierPath.strokeLineFromPoint(
								new NSPoint(width() * (2f / 3f),height() / 2f),
								arrowCapPoint); // /
			}
		}
		else
		{
			image.compositeToPointFromRect(r.origin(),r,NSImage.CompositeSourceOver);
		}
	}
	
	public void mouseDown(NSEvent event)
	{
		scroll_timer = new NSTimer(
					0.03,
					this,
					new NSSelector("scroll",new Class[0]),
					new Object[0],
					true);
		SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(scroll_timer,NSRunLoop.DefaultRunLoopMode);
		//scroller_thread = new SCBalloonScrollerThread(this);
		//scroller_thread.start();
	}
	
	public void mouseUp(NSEvent event)
	{
		//scroller_thread.terminate();
		scroll_timer.invalidate();
	}
	
	protected void scroll()
	{
		/*NSRect oldrect = target.documentVisibleRect();
		NSPoint oldpoint = oldrect.origin();
		float old_x = oldpoint.x();
		float old_y = oldpoint.y();
		float max_vert_point = target.documentRect().height() - oldrect.height();
		
		if (type == SCBalloonSkinServer.ARROW_DOWN && old_y == 0) return;
		else if (type == SCBalloonSkinServer.ARROW_UP && old_y == max_vert_point) return;
		
		float x = old_x;
		float y = old_y + (type == SCBalloonSkinServer.ARROW_UP ? SCROLL_STEP : -1 * SCROLL_STEP);
		
		if (y < 0) y = 0;
		else if (y > max_vert_point) y = max_vert_point;
		
		target.scrollToPoint(new NSPoint(x,y));
		((SCBalloonTextView)target.documentView()).updateArrowsVisibilities();*/
		controller.scroll(type == SCBalloonSkinServer.ARROW_UP ? SCROLL_STEP : -1 * SCROLL_STEP);
	}
	
	public void updateVisibility()
	{
		NSRect current_visible_rect = target.documentVisibleRect();
		float current_vert_point = current_visible_rect.y();
		
		if (type == SCBalloonSkinServer.ARROW_UP)
		{
			float max_vert_point = target.documentRect().height() - current_visible_rect.height();
			setVisibility(current_vert_point < max_vert_point);
		}
		else
		{
			setVisibility(current_vert_point > 0f);
		}
	}
	
	protected void setVisibility(boolean isVisible)
	{
		if (this.isVisible != isVisible)
		{
			this.isVisible = isVisible;
			setNeedsDisplay(true);
		}
	}
	
	public float width()
	{
		return bounds().width();
	}
	
	public float height()
	{
		return bounds().height();
	}
	
	public void setFrameOrigin(float x,float y)
	{
		setFrameOrigin(new NSPoint(x,y));
	}
	
	/*private class SCBalloonScrollerThread extends Thread
	{
		SCBalloonScrollArrow arrow;
		volatile boolean flag_term = false;
		
		public SCBalloonScrollerThread(SCBalloonScrollArrow arrow)
		{
			this.arrow = arrow;
		}
		
		public void run()
		{
			int pool = NSAutoreleasePool.push();
			
			while (!flag_term)
			{
				arrow.scroll();
				
				try{
					sleep(50);
				} catch (InterruptedException e){}
			}
			
			NSAutoreleasePool.pop(pool);
		}
		
		public void terminate()
		{
			flag_term = true;
			interrupt();
			while (isAlive()) {}
		}
	}*/
}
