/*
	$Id: SCDescription.java,v 1.3 2002/12/08 16:10:04 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class SCDescription
{
    Hashtable table; // gStringB
    
    public SCDescription()
    {
		// ̃CX^X쐬܂B
		table = new Hashtable();
    }
    
    public SCDescription(File f)
    {
		// fdescript.txt̃t@CB
        // S[Xg̃[gɂo[XLɂ肷t@CłB
        // tH[}bg͓Ȃ̂łǂɂg܂B
        // t@C݂Ȃȗꂽ̂Ƃ܂B
		table = new Hashtable();
		
		try
		{
			load(new FileInputStream(f));
		}
		catch (FileNotFoundException e) {}
    }
    
    public SCDescription(InputStream is)
    {
		table = new Hashtable();
		load(is);
    }
    
    public SCDescription(SCDescription parent,File f)
    {
		// parentI[o[ChSCDescription쐬܂B
		// t@C݂Ȃȗꂽ̂Ƃ܂B
		
		// Rs[
		table = (Hashtable)parent.getHashtable().clone();
		
		try
		{
			load(new FileInputStream(f));
		}
		catch (FileNotFoundException e) {}
    }
    
    public SCDescription(SCDescription parent,InputStream is)
    {
		// Rs[
		table = (Hashtable)parent.getHashtable().clone();
		
		load(is);
    }
    
    private void load(InputStream is)
    {
        BufferedReader br = null;
        try
        {
            br = new BufferedReader(new InputStreamReader(is,"SJIS"));
        }catch(Exception e){ return; }
        
        String line = null;
        while(true)
        {
            try{  line = br.readLine();  }catch(Exception e){}
            
            if (line == null) break;
            if (line.indexOf(',') == -1) continue;
	    
			// 劇ʂň͂܂Ă͈͖͂B
			if (line.equals("{"))
			{
				while(true)
				{
					try{  line = br.readLine();  }catch(Exception e){}
					if (line == null || line.equals("}")) break;
				}
				// ŏIIcontinueĕʂXLbvB
				continue;
			}
            
            // R}ɑOŕB
            int comma_pos = line.indexOf(',');
            String label = line.substring(0,comma_pos).trim(); // 9 septiembre 2002
            String data = line.substring(comma_pos+1).trim(); // 9 septiembre 2002
            
            // fBNViɃZbg
            table.put(label,data);
        }
	
		try{ br.close(); }catch(IOException e){}
    }
    
    public void save(File dest) throws Exception
    {
		try
		{
			if (dest.exists()) dest.delete();
			OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(dest),"SJIS");
			
			Object[] elements = table.entrySet().toArray(); // content : (Map.Entry)Gg
			for (int i = 0;i < elements.length;i++)
			{
				Map.Entry entry = (Map.Entry)elements[i];
				String line = (String)entry.getKey() + ',' + (String)entry.getValue() + "\r\n";
				osw.write(line,0,line.length());
			}
			
			osw.flush();
			osw.close();
		}
		catch (Exception e)
		{
			throw e;
		}
    }
    
    public boolean exists(String key)
    {
		return table.containsKey(key);
    }
    
    public String getStrValue(String key)
    {
		return (String)table.get(key);
    }
    
    public void setStrValue(String key,String data)
    {
		table.put(key,data);
    }
    
    public void setIntValue(String key,int data)
    {
		table.put(key,Integer.toString(data));
    }
    
    public int getIntValue(String key)
    {
        // f[^݂Ȃ萔lłȂ0Ԃ܂B
        String strval = getStrValue(key);
        if (strval == null) return 0;
        
        int val = 0;
        try
        {
            val = Integer.parseInt(strval);
        }
        catch (Exception e) {}
        
        return val;
    }
    
    public void remove(String key)
    {
		table.remove(key);
    }
    
    public Object inverseSearch(Object data)
    {
		// nbVe[utāAL[Ԃ܂B
		Object[] elements = table.entrySet().toArray(); // content : (Map.Entry)Gg
		for (int i = 0;i < elements.length;i++)
		{
			Map.Entry entry = (Map.Entry)elements[i];
			if (entry.getValue().equals(data)) return entry.getKey();
		}
		return null;
    }
    
    public Vector getKeysStartsWith(String key)
    {
		// w肳ꂽŎn܂L[SĔoĕԂ܂B
		// ԂꂽzɕKvɉăf[^QƂȂǂĉB
		// Ȃ΋̔z񂪕Ԃ܂B
		Vector result = new Vector();
		
		Vector allkeys = getAllKeys();
		int n_keys = allkeys.size();
		for (int i = 0;i < n_keys;i++)
		{
			if (((String)allkeys.elementAt(i)).startsWith(key))
			{
				result.add(allkeys.elementAt(i));
			}
		}
		
		return result;
    }
    
    public Vector getAllKeys()
    {
		Vector result = new Vector();
		
		Object[] elements = table.entrySet().toArray(); // content : (Map.Entry)Gg
		for (int i = 0;i < elements.length;i++)
		{
			Map.Entry entry = (Map.Entry)elements[i];
			result.add(entry.getKey());
		}
		
		return result;
    }
    
    protected Hashtable getHashtable()
    {
		return table;
    }
}
