/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.lang.*;
import java.util.*;

// checkengmakoto.dll 1.02 

public class SCExtMakoto
{
    public SCExtMakoto(File makotofile)
    {
        // ܂listt@C͖B
    }
    
    public static boolean checkIfUsable(File makotofile)
    {
        // makoto.dll̃oCit@CuMakoto Basic with Select and Repeatv̕B
	return (SCFileUtils.findData(makotofile,"Makoto Basic with Select and Repeat".getBytes()) != -1);
    }
    
    public void terminate()
    {
        // do nothing
    }
    
    public static String getModuleName()
    {
	return "\u62e1\u5f35makoto.dll"; // gmakoto.dll
    }
    
    public String translate(String param)
    {
        int str_len = param.length();
        int start = -1,end = -1;
        boolean esc = false;
        
        for (int i = 0;i < str_len;i++)
        {
            char cur_point = param.charAt(i);
            switch (cur_point)
            {
                case	'(':
                    if (!esc) start = i;
                    break;
                    
                case	')':
                    if (!esc && start != -1) end = i;
                    break;
            }
            if (cur_point == '\\') {esc = !esc;} else {esc = false;}
            if (start != -1 && end != -1) break;
        }
        if (start == -1 || end == -1)
        {
            // ʂȂ̂ŏIB
            return remove_yen(remove_yen(param,'('),')');
        }
        
        // I
        String workstr = param.substring(start + 1,end); // ʂ͍B
        workstr = select(workstr);
        
        boolean repeated = false;
        // 
        if (end < param.length() - 1 && Character.isDigit(param.charAt(end + 1)))
        {
            repeated = true;
            int n_maxreptimes = 0;
            try{  n_maxreptimes = Character.digit(param.charAt(end+1),10);  }catch(Exception e){}
            
	    int n_reptimes = (int)((Math.random() * 10000) % n_maxreptimes);
            StringBuffer rep_result = new StringBuffer();
            for (int i = 0;i < n_reptimes;i++)
            {
                rep_result.append(workstr);
            }
            workstr = rep_result.toString();
        }
        
        // O̕ƂčċAB
        StringBuffer sb = new StringBuffer(param);
        if (repeated)
        {
            sb.replace(start,end+2,workstr); // w̐
        }
        else
        {
            sb.replace(start,end+1,workstr);
        }
        return translate(sb.toString());
    }
    
    private String select(String param)
    {
        StringTokenizer st = new StringTokenizer(param,"|");
        int n_tokens = st.countTokens();
        if (n_tokens <= 1) // ĂȂ炻̂܂ܑԂB
        {
            return param;
        }
        
        // id_tokensԖڂ̃g[NɌB
	int id_tokens = (int)((Math.random() * 10000) % n_tokens);
        // id_tokensXLbvB
        for (int i = 0;i < id_tokens;i++) {st.nextToken();}
        return st.nextToken(); // ʂ͊O܂܁B
    }
    
    private String remove_yen(String param,char key)
    {
        // key̒Oɂ\폜B
        int pos = 0;
        int len = param.length();
        StringBuffer buf = new StringBuffer(param);
        while(true)
        {
            pos = buf.toString().indexOf(key,pos);
            if (pos == -1 || pos == len - 1) break; // I
            if (pos == 0) {pos++; continue;} // ̊ʂT
            if (buf.charAt(pos - 1) == '\\')
            {
                // \폜JE^posZbgčŏ猟ȂB
                // łȂƂꂽꂽ񂩂瑶݂锤\ƂꂪB
                buf.deleteCharAt(pos - 1);
                pos = 0;
                continue;
            }
            
            pos++;
        }
        return buf.toString();
    }
    
    public String request(String req)
    {
	BufferedReader br = new BufferedReader(new StringReader(req));
	
	// ܂̓wb_ǂ
	String header = null;
	try{ header = br.readLine(); }catch (Exception e){}
	
	// NGXgŜǂ
	Hashtable hash = new Hashtable();
	String line = null;
	while (true)
	{
	    try{ line = br.readLine(); }catch (Exception e){}
	    if (line == null) break;
	    if (line.indexOf(':') == -1) continue;
	    
	    String label = line.substring(0,line.indexOf(':'));
	    String data = line.substring(line.indexOf(':')+2); // R̎̃Xy[X͖
	    
	    hash.put(label,data);
	}
	
	try{ br.close(); }catch(IOException e){}
	
	// ߊJnB
	if (header.startsWith("EXECUTE"))
	{
	    String param = (String)hash.get("String");
	    if (param == null)
	    {
		return "MAKOTO/2.0 400 Bad Request\r\n\r\n";
	    }
	    else
	    {
		return "MAKOTO/2.0 200 OK\r\nString: "+translate(param)+"\r\n\r\n";
	    }
	}
	else
	{
	    return "MAKOTO/2.0 400 Bad Request\r\n\r\n";
	}
    }
}
