/*
	$Id: SCSeriko.java,v 1.2 2002/12/08 16:10:06 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
    SCSeriko
    
    SERIKȎSĂ̓̊Ǘs܂B
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class SCSeriko
{
    private final SCSerikoLibrary seriko_lib;
    private SCSerikoSeqGroup current_hontai_group,current_unyuu_group;
    private SCSerikoBindCenter bindCenter;
    private Vector runners; // gSCSerikoSequenceRunnerB
    private boolean exclusive_locked = false; // option[exclusive]̃V[PX쒆̎trueBexecute\bh̃R[֎~܂B
    
    SCSession session;
    SCShell shell;
    
    public SCSeriko(SCSession session,SCShell shell,File shelldir)
    {
		this.session = session;
		this.shell = shell;
		
		seriko_lib = new SCSerikoLibrary(shell);
		runners = new Vector();
		bindCenter = new SCSerikoBindCenter(session,shell,this);
    }
    
    public void dumpLibrary()
    {
		seriko_lib.dump();
    }
    
    public void surfaceChanged(int new_id,boolean hontai)
    {
		// T[tBXςꂽɌĂ΂܂B
		// ܂ł̃Aj[VN[AbvAVȃV[PXO[v̏펞NnGgN܂B
		// T[tBXIDƃV[PXO[vID́ARłB
		
		// N[Abv
		terminateAllRunnersThread(hontai);
		bindCenter.disableAll();
		
		SCSerikoSeqGroup target;
		// JgO[vύX
		if (hontai)
		{
			current_hontai_group = seriko_lib.findSeqGroup(new_id);
			target = current_hontai_group;
		}
		else
		{
			current_unyuu_group = seriko_lib.findSeqGroup(new_id);
			target = current_unyuu_group;
		}
		
		if (target == null) return;
		
		execute(target.makeSequenceArray("runonce"),hontai);
		execute(target.makeSequenceArray("always"),hontai);
		execute(target.makeSequenceArray("random"),hontai);
		
		bindCenter.enableCheckedBindGroups();
    }
    
    public void execute(Vector sequences,boolean hontai)
    {
		int n_sequences = sequences.size();
		for (int i = 0;i < n_sequences;i++)
		{
			SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
			execute(seq.id(),hontai);
		}
    }
    
    public void execute(int seqid,boolean hontai)
    {
		// ݂̃O[v̎w肳ꂽV[PX𑖂点܂B
		// V[PX^Cvbindꍇł삵܂B
		// exclusivebNȂ牽s܂B
		if (SCFoundation.STOP_SERIKO) return;
		if (isExclusiveLocked()) return;
		
		SCSerikoSeqGroup group = (hontai ? current_hontai_group : current_unyuu_group);
		if (group == null) return;
		SCSerikoSequence seq = group.findSequence(seqid);
		if (seq == null) return;
		
		// ɏIĂ郉i[̓Xg폜B
		// ȂalwaysstartgꂽɔߌNB
		int n_runners = runners.size();
		for (int i = 0;i < n_runners;i++)
		{
			SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
			if (!runner.isAlive())
			{
				runners.removeElementAt(i);
				n_runners--; // 1B
				i--; // iςɂ܂[vB
			}
		}
		SCSerikoSequenceRunner runner = new SCSerikoSequenceRunner(this,shell,seq,hontai,session);
		runners.add(runner);
		runner.start();
    }
    
    public void terminateAllRunnersOverlay()
    {
		// ͂@B
		int n_runners = runners.size();
		for (int i = 0;i < n_runners;i++)
		{
			SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
			runner.terminateOverlay();
		}
    }
    
    public void terminateAllRunnersOverlay(boolean hontai)
    {
		// ͂@B
		int n_runners = runners.size();
		for (int i = 0;i < n_runners;i++)
		{
			SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
			if (runner.isHontai() == hontai) runner.terminateOverlay();
		}
    }
    
    public void terminateAllRunnersThread()
    {
		// ͂@B
		
		int n_runners = runners.size();
		for (int i = 0;i < n_runners;i++)
		{
			SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
			runner.terminateThread();
		}
    }
    
    public void terminateAllRunnersThread(boolean hontai)
    {
		// ͂@B
		int n_runners = runners.size();
		for (int i = 0;i < n_runners;i++)
		{
			SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
			if (runner.isHontai() == hontai) runner.terminateThread();
		}
    }
    
    public void terminateTargetRunner(int target_id,boolean hontai)
    {
		int n_runners = runners.size();
		for (int i = 0;i < n_runners;i++)
		{
			SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
			if (runner.getSeqID() == target_id && runner.isHontai() == hontai) runner.terminateThread();
		}
    }
    
    public void setExclusiveLocked(boolean b)
    {
		exclusive_locked = b;
    }
    
    public boolean isExclusiveLocked()
    {
		return exclusive_locked;
    }
    
    public SCSerikoSeqGroup getCurrentSeqGroup(boolean hontai)
    {
		return (hontai ? current_hontai_group : current_unyuu_group);
    }
    
    public void terminate()
    {
		// SERIKOI܂B
		terminateAllRunnersOverlay();
		terminateAllRunnersThread();
		bindCenter.terminate();
    }
    
    public SCSerikoBindCenter getBindCenter()
    {
		// ւj[݂ȂnullB
		return bindCenter;
    }
}
