/*
	$Id: SCSerikoSeqGroup.java,v 1.2 2002/12/08 16:10:06 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
    SCSerikoSeqGroup
    
    IDɊ܂܂SẴV[PXf[^Ǘ܂B
    ܂surface[id]a.txtt@C̈̃NXɑΉ܂B
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class SCSerikoSeqGroup
{
    Vector sequences; // gSCSerikoSequence
    int seqGroupId;
    
    public SCSerikoSeqGroup(File f,int seqGroupId)
    {
		// f : *a.txt
		sequences = new Vector();
		this.seqGroupId = seqGroupId;
		if (!f.exists() || f.isDirectory()) return; // 肦ȂǁB
		
		try
		{
			BufferedReader br = null;
			br = new BufferedReader(new InputStreamReader(new FileInputStream(f),"SJIS"));
			
			Vector definitions = new Vector();
			while(true)
			{
				String line = br.readLine();
				
				if (line == null) break; // EOF
				if (line.length() == 0) continue;
				if (!Character.isDigit(line.charAt(0))) continue; // Ŏn܂Ȃs̓XLbvB
				
				definitions.add(line);
			}
			load(definitions);
			
			br.close();
		}
		catch(IOException e)
		{
			System.err.println("SCSerikoSeqGroup : exception occured in loading "+f.getName());
			e.printStackTrace();
		}
    }
    
    public void dump()
    {
		System.out.println("*************");
		System.out.println("SequenceGroup ID : "+seqGroupId);
		final int n_sequences = sequences.size();
		for (int i = 0;i < n_sequences;i++)
		{
			SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
			seq.dump();
		}
		System.out.println("");
    }
    
    public SCSerikoSeqGroup(Vector definitions,int seqGroupId)
    {
		// definitions : <String>V[PX`s̏W
		// V[PX`łȂڂ܂܂Ă琳B
		sequences = new Vector();
		this.seqGroupId = seqGroupId;
		
		Vector valid_defs = new Vector();
		final int n_defs = definitions.size();
		for (int i = 0;i < n_defs;i++)
		{
			String def = (String)definitions.elementAt(i);
			
			// lŎn܂Ă΃V[PX`sƌ􂷁B
			if (Character.isDigit(def.charAt(0)))
			{
				valid_defs.add(def);
			}
		}
		
		load(valid_defs);
    }
    
    protected void load(Vector definitions)
    {
		// definitions : <String>V[PX`s̏W
		final int n_lines = definitions.size();
		for (int i = 0;i < n_lines;i++)
		{
			String line = (String)definitions.elementAt(i);
			
			// V[PXIDoB
			// 擪琔A̓V[PXIDłB
			int seq_id_length = 0;
			while (Character.isDigit(line.charAt(seq_id_length))) seq_id_length++;
			
			int seqId = -1;
			try{ seqId = Integer.parseInt(line.substring(0,seq_id_length)); }catch(Exception e){}
			
			// V[PXIDɑΉSCSerikoSequenceɊi[B
			SCSerikoSequence seq = findSequence(seqId,true); // ߂ČV[PXIDȂVɍ쐬B
			seq.add(line.substring(seq_id_length));
			
			/*
			Ȃō߂iƂՔnHj́A
			[seqID][entryType][Index],{parameters}
			̓Iɂ͗Ⴆ΁A0pattern0,100,...
			ȂĂ`ɂł傤B
			0,pattern,0,100,...
			ɂĂ΃J}ŋ؂Ĉꔭ̂ɁB
			߂ǂȃ@B
			*/
		}
    }
    
    public int groupId()
    {
		return seqGroupId;
    }
    
    public SCSerikoSequence findSequence(int seqid)
    {
		// V[PXIDSCSerikoSequenceԂ܂B
		// ȂnullԂ܂B
		return findSequence(seqid,false);
    }
    
    private SCSerikoSequence findSequence(int seqid,boolean makenew)
    {
		// V[PXIDSCSerikoSequenceA
		// ȂmakenewtrueȂVɍ쐬ăXgɒǉĂԂA
		// falseȂnullԂ܂B
		int n_sequences = sequences.size();
		for (int i = 0;i < n_sequences;i++)
		{
			SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
			if (seq.id() == seqid) return seq;
		}
		
		// Not Found
		if (makenew)
		{
			SCSerikoSequence new_seq = new SCSerikoSequence(seqid);
			sequences.add(new_seq);
			return new_seq;
		}
		else
		{
			return null;
		}
    }
    
    public Vector makeSequenceArray(String interval)
    {
		// w肳ꂽinterval^CvSẴV[PXiSCSerikoSequenceNXjԂ͍lɕׂVector쐬ĕԂ܂B
		// runoncebindŎg܂B
		Vector result = new Vector();
		
		int n_sequences = sequences.size();
		for (int i = 0;i < n_sequences;i++)
		{
			SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
			if (seq.interval().type().equals(interval))
			{
				result.add(seq);
			}
		}
		
		return result;
    }
}
