/*
	$Id: SCSerikoSequence.java,v 1.2 2002/12/08 16:10:06 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
    SCSerikoSequence
    
    V[PX\܂B
    ႦΎ̂悤Ȃ̂łB
    
    0interval,sometimes
    0pattern0,100,5,overlay,0,0
    0pattern1,101,5,overlay,0,0
    0pattern2,100,5,overlay,0,0
    0pattern3,-1,5,overlay,0,0
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCSerikoSequence
{
    SCSerikoSeqIntervalEntry interval; // intervalGg̒gB
    SCSerikoSeqOptionEntry option; // optionGg̒gBȗĂnullB
    Vector patterns; // patternGg̒gBgSCSerikoSeqPatternEntry܂NSNullBp^[IDƔzID͊SɈv܂B
    int seq_id;
    
    public SCSerikoSequence(int seq_id)
    {
		patterns = new Vector();
		this.seq_id = seq_id;
    }
    
    public void dump()
    {
		System.out.println("### Sequence ID : "+seq_id);
		interval.dump();
		if (option != null) option.dump();
		
		final int n_pats = patterns.size();
		for (int i = 0;i < n_pats;i++)
		{
			Object entry = patterns.elementAt(i);
			if (entry instanceof SCSerikoSeqPatternEntry) ((SCSerikoSeqPatternEntry)entry).dump();
		}
    }
    
    public void add(String dataline)
    {
		/*
			VɃGgǉ܂B
			Gǧ`
			interval,sometimes
			pattern0,100,5,overlay,0,0
			łāA
			0interval,sometimes
			0pattern0,100,5,overlay,0,0
			ł͂܂B
		*/
		
		if (dataline.startsWith("interval"))
		{
			interval = new SCSerikoSeqIntervalEntry( dataline.substring(9) );
		}
		else if (dataline.startsWith("pattern") || dataline.startsWith("patturn"))
		{
			/*
			Քn̎dľ뎚ŁApatternpatturnɂȂĂB
			̂߂ÃV[PXLqɊԈႢB
			dȂ̂patturnłF悤ɂB
			*/
			
			// p^[IDoB
			int pat_id_begin = 7;
			int pat_id_end = 7;
			while (Character.isDigit(dataline.charAt(pat_id_end))) pat_id_end++;
			int patId = -1;
			try{ patId = Integer.parseInt(dataline.substring(pat_id_begin,pat_id_end)); }catch(Exception e){}
			
			// ̃p^[IDɑΉSCSerikoSeqPatternEntryɃf[^i[B
			setPatternEntry(patId, dataline.substring(pat_id_end) );
		}
		else if (dataline.startsWith("option"))
		{
			option = new SCSerikoSeqOptionEntry( dataline.substring(7) );
		}
    }
    
    public int id()
    {
		return seq_id;
    }
    
    public SCSerikoSeqIntervalEntry interval()
    {
		return interval;
    }
    
    public SCSerikoSeqOptionEntry option()
    {
		return option; // ȗĂnullԂ܂B
    }
    
    public Vector patterns()
    {
		// SĂpatternGgԂ܂B
		// z̃CfBbNXƃp^[CfBbNX͈vĂ̂ŁA
		// ԍĂꍇNSNullŃpfBOĂ܂B
		return patterns;
    }
    
    private void setPatternEntry(int patId,String pattern_param)
    {
		// patternspatIdɑΉʒuɃf[^Zbg܂B
		// KvȂNSNullŃpfBO܂B
		SCSerikoSeqPatternEntry patEntry = new SCSerikoSeqPatternEntry(pattern_param);
		
		if (patterns.size() >= patId+1) // Ƀf[^Ă̂ŁÂB
		{
			patterns.setElementAt(patEntry,patId);
		}
		else
		{
			// KvȂNSNullŃpfBOB
			while (patId > patterns.size())
			{
				patterns.add(NSNull.nullValue());
			}
			
			patterns.add(patEntry);
		}
    }
}
