/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori;
import satori.*;
import satori.saori.*;
import java.io.*;
import java.util.*;

public class Satori
{
    public static final char ZENKAKU_BYOU = '\u79d2'; // b
    public static final char ZENKAKU_KAGIKAKKO_OPEN = '\u300c'; // u
    public static final char ZENKAKU_KAGIKAKKO_CLOSE = '\u300d'; // v
    public static final char ZENKAKU_RIGHT_ARROW = '\u2192'; // 
    public static final char ZENKAKU_DOUBLE_GT = '\u226b'; // 
    public static final char[] ZENKAKU_DAYOFWEEK = {'\u65e5','\u6708','\u706b','\u6c34',
						    '\u6728','\u91d1','\u571f'}; // `y
    public static final char ZENKAKU_KUTEN = '\u3002'; // B
    public static final char ZENKAKU_TOUTEN = '\u3001'; // A
	public static final char ZENKAKU_FAI = '\u03c6'; // 
    
    public static final String ZENKAKU_SAVEDATA = "\u30bb\u30fc\u30d6\u30c7\u30fc\u30bf"; // Z[uf[^
	public static final String ZENKAKU_INITIALIZE = "\u521d\u671f\u5316"; // 
    public static final String ZENKAKU_SHABERI_KANKAKU = "\u558b\u308a\u9593\u9694"; // Ԋu
    public static final String ZENKAKU_SHABERI_KANKAKU_GOSA = "\u558b\u308a\u9593\u9694\u8aa4\u5dee"; // Ԋu덷
    public static final String ZENKAKU_COMMENT = "\u30b3\u30e1\u30f3\u30c8"; // Rg
    public static final String ZENKAKU_EVENT_NAME = "\u30a4\u30d9\u30f3\u30c8\u540d"; // Cxg
    public static final String ZENKAKU_DIC_DIR = "\u8f9e\u66f8\u30d5\u30a9\u30eb\u30c0"; // tH_
    public static final String ZENKAKU_RELOAD_DIC = "\u8f9e\u66f8\u30ea\u30ed\u30fc\u30c9"; // [h
    public static final String ZENKAKU_JIKKOU = "\u5b9f\u884c"; // s
    public static final String ZENKAKU_CHANGING_SCOPE = "\u30b9\u30b3\u30fc\u30d7\u5207\u308a\u66ff\u3048\u6642"; // XR[v؂ւ
    public static final String ZENKAKU_AUTOINSERT_WAIT_RATE = "\u81ea\u52d5\u633f\u5165\u30a6\u30a7\u30a4\u30c8\u306e\u500d\u7387"; // }EFCg̔{
    public static final String ZENKAKU_AUTORESET_SURFACES = "\u4f1a\u8a71\u6642\u30b5\u30fc\u30d5\u30a7\u30b9\u623b\u3057"; // bT[tFX߂
    public static final String ZENKAKU_DEFAULT_SURFACE = "\u30c7\u30d5\u30a9\u30eb\u30c8\u30b5\u30fc\u30d5\u30a7\u30b9"; // ftHgT[tFXim
    public static final String ZENKAKU_WHAT_TO_LEARN = "\u6559\u308f\u308b\u3053\u3068"; // 邱
    public static final String ZENKAKU_TEACHED = "\u3092\u6559\u3048\u3066\u3082\u3089\u3063\u305f"; // Ă
    public static final String ZENKAKU_COMMNUCATE_NO_MATCHES = "COMMUNICATE\u8a72\u5f53\u306a\u3057"; // COMMUNICATEYȂ
    public static final String ZENKAKU_GHOST_STANDS_BY_THIS = "\u96a3\u3067\u8d77\u52d5\u3057\u3066\u3044\u308b\u30b4\u30fc\u30b9\u30c8"; // ׂŋNĂS[Xg
    public static final String ZENKAKU_ENABLED = "\u6709\u52b9"; // L
    public static final String ZENKAKU_RUIKEIJI = "\u7d2f\u8a08\u6642"; // ݌v
    public static final String ZENKAKU_RUIKEIFUN = "\u7d2f\u8a08\u5206"; // ݌v
    public static final String ZENKAKU_RUIKEIBYOU = "\u7d2f\u8a08\u79d2"; // ݌vb
    public static final String ZENKAKU_GENZAINEN = "\u73fe\u5728\u5e74"; // ݔN
    public static final String ZENKAKU_GENZAITSUKI = "\u73fe\u5728\u6708"; // ݌
    public static final String ZENKAKU_GENZAINICHI = "\u73fe\u5728\u65e5"; // ݓ
    public static final String ZENKAKU_GENZAIYOUBI = "\u73fe\u5728\u66dc\u65e5"; // ݗj
    public static final String ZENKAKU_GENZAIJI = "\u73fe\u5728\u6642"; // ݎ
    public static final String ZENKAKU_GENZAIFUN = "\u73fe\u5728\u5206"; // ݕ
    public static final String ZENKAKU_GENZAIBYOU = "\u73fe\u5728\u79d2"; // ݕb
    public static final String ZENKAKU_KIDOUJI = "\u8d77\u52d5\u6642"; // N
    public static final String ZENKAKU_KIDOUFUN = "\u8d77\u52d5\u5206"; // N
    public static final String ZENKAKU_KIDOUBYOU = "\u8d77\u52d5\u79d2"; // Nb
    public static final String ZENKAKU_SIMPLE = "\u5358\u7d14"; // P
    public static final String ZENKAKU_TIMER = "\u30bf\u30a4\u30de"; // ^C}
    public static final String ZENKAKU_RANDOM_NUMBER = "\u4e71\u6570"; // 
    public static final String ZENKAKU_EXISTANCE_OF = "\u306e\u5b58\u5728"; // ̑
    public static final String ZENKAKU_SURFACE_OF = "\u306e\u30b5\u30fc\u30d5\u30a3\u30b9"; // ̃T[tBX
    public static final String ZENKAKU_NUM_OF_GHOSTS = "\u8d77\u52d5\u3057\u3066\u3044\u308b\u30b4\u30fc\u30b9\u30c8\u6570"; // NĂS[Xg
    public static final String ZENKAKU_USER = "\u30e6\u30fc\u30b6"; // [U
    public static final String ZENKAKU_SURFACE_OFFSET = "\u30b5\u30fc\u30d5\u30a7\u30b9\u52a0\u7b97\u5024"; // T[tBXZl
    
    public static final Hashtable EVENT_REDIRECTS; // key : (String)Cxg , content : (String)փCxg
    static
    {
		EVENT_REDIRECTS = new Hashtable();
		EVENT_REDIRECTS.put("OnFirstBoot","\u521d\u56de"); // OnFirstBoot
		EVENT_REDIRECTS.put("\u521d\u56de","OnBoot"); // OnBoot
		EVENT_REDIRECTS.put("OnBoot","\u8d77\u52d5"); // OnBootN
		EVENT_REDIRECTS.put("OnClose","\u7d42\u4e86"); // OnCloseI
		EVENT_REDIRECTS.put("OnGhostChanged","\u4ed6\u306e\u30b4\u30fc\u30b9\u30c8\u304b\u3089\u5909\u66f4"); // OnGhostChanged̃S[XgύX
		EVENT_REDIRECTS.put("\u4ed6\u306e\u30b4\u30fc\u30b9\u30c8\u304b\u3089\u5909\u66f4","OnBoot"); // ̃S[XgύXOnBoot
		EVENT_REDIRECTS.put("OnGhostChanging","\u4ed6\u306e\u30b4\u30fc\u30b9\u30c8\u3078\u5909\u66f4"); // OnGhostChanging̃S[Xg֕ύX
		EVENT_REDIRECTS.put("\u4ed6\u306e\u30b4\u30fc\u30b9\u30c8\u3078\u5909\u66f4","OnClose"); // ̃S[Xg֕ύXOnClose
		EVENT_REDIRECTS.put("OnVanishSelecting","\u6d88\u6ec5\u6307\u793a"); // OnVanishSelectingŎw
		EVENT_REDIRECTS.put("OnVanishCancel","\u6d88\u6ec5\u64a4\u56de"); // OnVanishCancelœP
		EVENT_REDIRECTS.put("OnVanishSelected","\u6d88\u6ec5\u6c7a\u5b9a"); // OnVanishCancelŌ
		EVENT_REDIRECTS.put("OnVanishButtonHold","\u6d88\u6ec5\u4e2d\u65ad"); // OnVanishButtonHoldŒf
    }
    
    Dictionary dictionary;
    Evaluator evaluator;
    Variable variable;
    References references;
    Translator pre_translator,post_translator;
    SystemVariables sysVars;
	SaoriManager saori_manager;
    
    File ghost_dir;
    
    int talkCount = 0; // g[NJE^
    
    //----------- ȉ̏NOTIFYőĂ܂B------------//
    String ownerGhostName;
    Vector otherGhostNames; // <String[]>GhostEx@[0]=S[Xg [1]=sakuraT[tBXID [2]=keroT[tBXID
    //------------------------------------------------------------//
    
    public Satori(File ghost_dir)
    {
		this.ghost_dir = ghost_dir;
		
		dictionary = new Dictionary(this);
		evaluator = new Evaluator(this);
		variable = new Variable(new File(ghost_dir,"satori_savedata.txt"));
		references = new References();
		pre_translator = new Translator(new File(ghost_dir,"replace.txt"));
		post_translator = new Translator(new File(ghost_dir,"replace_after.txt"));
		saori_manager = new SaoriManager(this);
		
		otherGhostNames = new Vector();
		
		// satori_savedata.txtsatori_conf.txtTB
		File[] items = ghost_dir.listFiles();
		File savedata = null;
		File conf = null;
		final int n_items = items.length;
		for (int i = 0;i < n_items && (savedata == null || conf == null);i++)
		{
			if (items[i].getName().equals("satori_savedata.txt"))
			{
				savedata = items[i];
			}
			else if (items[i].getName().equals("satori_conf.txt"))
			{
				conf = items[i];
			}
		}
		
		// confǂłA
		if (conf != null)
		{
			// Ƃă[h
			dictionary.loadDicFile(conf);
			
			// ]
			Vector blocks = dictionary.getSentenceBlock(ZENKAKU_INITIALIZE);
			evaluator.evaluate((String)blocks.elementAt(0)); // ʂ͎̂ĂB
		}
		
		// savedataǂށB
		if (savedata != null)
		{
			// Ƃă[h
			dictionary.loadDicFile(savedata);
				
			// ]
			Vector blocks = dictionary.getSentenceBlock(ZENKAKU_SAVEDATA);
			evaluator.evaluate((String)blocks.elementAt(0)); // ʂ͎̂ĂB
		}
		
		// VXeϐ̓Z[uf[^ǂłłȂƍ쐬oȂB
		sysVars = new SystemVariables(this);
		sysVars.put(ZENKAKU_NUM_OF_GHOSTS,"1"); // ꂾ̓ZbgĂB
		
		reloadDictionary();
    }
    
    public void reloadDictionary()
    {
		// ϐutH_v`Ă炻̎wʂɓǂݍށB
		// `ȂJgfBNĝ݁B
		dictionary.resetAll();
		
		String dic_dir_definition = variable.get(ZENKAKU_DIC_DIR);
		if (dic_dir_definition != null)
		{
			StringTokenizer st = new StringTokenizer(dic_dir_definition,",");
			while (st.hasMoreTokens())
			{
				dictionary.loadAllDictionariesInDirectory(new File(ghost_dir,st.nextToken()));
			}
		}
		else
		{
			dictionary.loadAllDictionariesInDirectory(ghost_dir);
		}
    }
    
    public static boolean checkIfUsable(File ghost_dir)
    {
			// satori.dlltrueB
		return (new File(ghost_dir,"satori.dll")).exists();
    }
    
    public static boolean checkIfUsable(File ghost_dir,File shiori_dll)
    {
		// shiori_dll̖Osatori.dllȂtrueB
		// łȂshiori_dllsatori.dll̕񂪊܂܂ĂtrueB
		if (shiori_dll.getName().equals("satori.dll"))
		{
			return true;
		}
		else if (shiori_dll.exists())
		{
			return (findData(shiori_dll,"satori.dll".getBytes()) != -1);
		}
		else
		{
			return false;
		}
    }
	
	// import SCFileUtils;oȂȂ悤Ȃ̂ŃRsyB
	public static int findData(File f,byte[] data)
    {
		// t@CoCgA΂ꂪn܂ItZbgAȂ-1Ԃ܂B
		// ݂̎ł̓t@Cۂƃɓǂݍł܂̂ŁA܂ɋȃt@Cɑ΂Ă͗ps\łB
		try
		{
			FileInputStream fis = new FileInputStream(f);
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			byte[] buf = new byte[512];
			while (true)
			{
				int count = fis.read(buf);
				if (count == -1) break; // eof
				
				baos.write(buf,0,count);
			}
			byte[] world = baos.toByteArray();
			
			return findData(world,data);
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return -1;
		}
    }
	public static int findData(byte[] world,byte[] data) {
		// worlddataA΂̃ItZbgAȂ-1Ԃ܂B
		// Boyer Moore@pB
		int data_len = data.length;
		int[] skip = new int[256];
		for (int i = 0; i < 256; i++) {
			skip[i] = data_len;
		}
		for (int i = 0; i < data_len-1; i++) {
			// byte -> -128  +127 ܂ŁB
			// -1255ɁA-2254ɁAcA-128128ɑΉB
			// ܂A͈̔͂ł͂ꂼ(256 + n)ɑΉB
			skip[(data[i] < 0 ? 256 + data[i] : data[i])] = data_len - i - 1;
		}
		int limit = world.length - data.length;
		for (int i = 0; i <= limit; i += skip[(world[i+data_len-1] < 0 ? 256 + world[i+data_len-1] : world[i+data_len-1])]) {
			if (world[i+data_len-1] != data[data_len-1]) {
				continue;
			}
			
			boolean matched = true;
			for (int j = 0; j < data_len; j++) {
				if (world[i+j] != data[j]) {
					matched = false;
					break;
				}
			}
			if (matched) {
				return i;
			}
		}
		return -1;
	}
    
    public void terminate()
    {
		sysVars.close();
		variable.close(); // VXeϐɕĂ͂ȂȂB
    }
    
    public static String getModuleName()
    {
        return "\u91cc\u3005"; // X
    }
	
	public Evaluator getEvaluator()
	{
		return evaluator;
	}
    
    public Dictionary getDictionary()
    {
		return dictionary;
    }
    
    public Variable getVariable()
    {
		return variable;
    }
    
    public References getReferences()
    {
		return references;
    }
    
    public Translator getPreTranslator()
    {
		return pre_translator;
    }
    
    public Translator getPostTranslator()
    {
		return post_translator;
    }
    
    public SystemVariables getSysVars()
    {
		return sysVars;
    }
	
	public SaoriManager getSaoriManager()
	{
		return saori_manager;
	}
    
    public Vector getOtherGhostNames()
    {
		return otherGhostNames;
    }
    
    private String getSentenceBlockOfRandomTalk()
    {
		return selectStringAtRandom(dictionary.getSentenceBlock(""));
    }
    
    private Vector getSentenceBlockWithRedirectingRecursively(String eventName)
    {
		// ǌtȂnullԂ܂B
		Vector v = dictionary.getSentenceBlock(eventName);
		if (v != null)
		{
			return v; // 
		}
		else
		{
			// ֖̌₪L邩H
			String redirected = (String)EVENT_REDIRECTS.get(eventName);
			if (redirected != null) // L΍Č
			{
				return getSentenceBlockWithRedirectingRecursively(redirected); // ċA
			}
			else // ̂ŏI
			{
				return null;
			}
		}
    }
    
    public static Object selectObjectAtRandom(Vector vec)
    {
		// vecnullȂnullԂ܂B
		if (vec == null) return null;
		
		int select = (int)((Math.random() * Integer.MAX_VALUE) % vec.size());
		return vec.elementAt(select);
    }
    public static String selectStringAtRandom(Vector vec)
    {
		// vecnullȂnullԂ܂B
		return (String)selectObjectAtRandom(vec);
    }
	
	public static String encodeEscapedChars(String src)
	{
		// ӂŃGXP[vꂽGR[hB
		StringBuffer result = new StringBuffer();
		
		final int len = src.length();
		for (int i = 0;i < len;i++)
		{
			char c = src.charAt(i);
			if (c != ZENKAKU_FAI)
			{
				result.append(c);
			}
			else
			{
				if (i == len-1) // s̃
				{
					result.append(c);
				}
				else if (src.charAt(i+1) == ZenHanTranslator.ZENKAKU_PARENTHESIS_OPEN) // Ӂi
				{
					result.append("%%%-WIDE-PAREN-OPEN-%%%");
					i++; // iXLbv
				}
				else if (src.charAt(i+1) == ZenHanTranslator.ZENKAKU_PARENTHESIS_CLOSE) // Ӂj
				{
					result.append("%%%-WIDE-PAREN-CLOSE-%%%");
					i++; // jXLbv
				}
				else if (src.charAt(i+1) == ZENKAKU_FAI) // Ӄ
				{
					result.append("%%%-WIDE-FAI-%%%");
					i++; // ӂXLbv
				}
				// ǂɂYȂA܂GXP[vKv̖ꏊŃӂꂽPɃӂB
			}
		}
		
		return result.toString();
	}
	
	public static String decodeEscapedChars(String src)
	{
		// ӂŃGXP[vꂽfR[hB
		StringBuffer result = new StringBuffer();
		
		final int len = src.length();
		for (int i = 0;i < len;)
		{
			if (src.startsWith("%%%-WIDE-PAREN-OPEN-%%%",i))
			{
				result.append(ZenHanTranslator.ZENKAKU_PARENTHESIS_OPEN);
				i += "%%%-WIDE-PAREN-OPEN-%%%".length();
			}
			else if (src.startsWith("%%%-WIDE-PAREN-CLOSE-%%%",i))
			{
				result.append(ZenHanTranslator.ZENKAKU_PARENTHESIS_CLOSE);
				i += "%%%-WIDE-PAREN-CLOSE-%%%".length();
			}
			else if (src.startsWith("%%%-WIDE-FAI-%%%",i))
			{
				result.append(ZENKAKU_FAI);
				i += "%%%-WIDE-FAI-%%%".length();
			}
			else
			{
				result.append(src.charAt(i));
				i++;
			}
		}
		
		return result.toString();
	}
    
    private String secondChanged(Hashtable requestTable)
    {
		// OnSecondChangeœJE^Ig[NB
		sysVars.update();
		
		// ^C}[B
		String timer_fired = variable.updateTimer();
		if (timer_fired != null)
		{
			String sentence = selectStringAtRandom(dictionary.getSentenceBlock(timer_fired));
			if (sentence != null)
			{
				return generateResponce200(sentence,requestTable);
			}
		}
	
		// ref1 == 1 || ref2 == 1 || ref3 == 0̏𖞂ĂΎg[NsȂB
		String ref1 = (String)requestTable.get("Reference1");
		String ref2 = (String)requestTable.get("Reference2");
		String ref3 = (String)requestTable.get("Reference3");
		if (ref1.equals("1") || ref2.equals("1") || ref3.equals("0")) return "SHIORI/2.0 204 No Content\r\n\r\n";
		
		// g[NB܂͒Ԋuϐ擾B
		try
		{
			String interval_str = variable.get(ZENKAKU_SHABERI_KANKAKU);
			if (interval_str.charAt(interval_str.length()-1) != ZENKAKU_BYOU)
			{
				return "SHIORI/2.0 204 No Content\r\n\r\n";
			}
	    
			int interval = Integer.parseInt(interval_str.substring(0,interval_str.length()-1));
			
			String error_percent_str = variable.get(ZENKAKU_SHABERI_KANKAKU_GOSA);
			int error_percent;
			if (error_percent_str == null || error_percent_str.charAt(error_percent_str.length()-1) != '%')
			{
				error_percent = 0; // 0%
			}
			else
			{
				error_percent = Integer.parseInt(error_percent_str.substring(0,error_percent_str.length()-1));
			}
	    
			int signal = ((int)((Math.random() * 1000) % 2) == 0 ? 1 : -1);
			int error = (int)(interval * ((error_percent / 100.0) * signal * Math.random()));
			interval += error; // ŊԊu܂B
			
			//System.out.println("interval: "+interval+", talkCount: "+talkCount);
			
			talkCount++;
			if (talkCount > interval)
			{
				talkCount = 0;
				//return "SHIORI/2.0 200 OK\r\nSentence: \\a\r\n\r\n";
				String sentenceToReturn = getSentenceBlockOfRandomTalk();
				return (sentenceToReturn == null ? "SHIORI/2.0 204 No Content\r\n\r\n" : generateResponce200(sentenceToReturn,requestTable));
			}
			else
			{
				return "SHIORI/2.0 204 No Content\r\n\r\n";
			}
		}
		catch (Exception e)
		{
			return "SHIORI/2.0 204 No Content\r\n\r\n";
		}
	}
    
    public String request(String req)
	{
		BufferedReader br = new BufferedReader(new StringReader(req));
		
		// ܂̓wb_ǂ
		String header = null;
		try{ header = br.readLine(); }catch (Exception e){}
		
		// NOTIFY OtherGhostName͑ĂGgdĂBN\I
		if (header.startsWith("NOTIFY OtherGhostName"))
		{
			otherGhostNames.clear();
			
			String line = null;
			while (true)
			{
				try{ line = br.readLine(); }catch (Exception e){}
				if (line == null) break;
				if (!line.startsWith("GhostEx: ")) continue;
				
				StringTokenizer st = new StringTokenizer(line.substring(line.indexOf(':')+1).trim(),"\u0001");
				String[] elems = new String[3];
				elems[0] = st.nextToken();
				elems[1] = st.nextToken();
				elems[2] = st.nextToken();
				otherGhostNames.add(elems);
			}
			sysVars.put(ZENKAKU_NUM_OF_GHOSTS,""+otherGhostNames.size()+1); // ܂߂S[XgB
			
			try{ br.close(); }catch(IOException e){}
			return "SHIORI/2.3 204 No Content\r\n\r\n"; 
		}
	
		// t@XZbg
		references.clearAll();
		
		// NGXgŜǂ
		Hashtable hash = new Hashtable();
		String line = null;
		while (true)
		{
			try{ line = br.readLine(); }catch (Exception e){}
			if (line == null) break;
			if (line.indexOf(':') == -1) continue;
			
			String label = line.substring(0,line.indexOf(':'));
			String data = line.substring(line.indexOf(':')+2); // R̎̃Xy[X͖
			
			hash.put(label,data);
			sysVars.put(label,data);
		}
	
		try{ br.close(); }catch(IOException e){}
		
		// ߊJnB
		if (header.startsWith("GET Sentence"))
		{
			if (hash.get("Event") != null) // Cxgt
			{
				String event = (String)hash.get("Event");
				// Event -> Cxg o^
				sysVars.put(ZENKAKU_EVENT_NAME,event);
				
				// Reference0 -> qO o^
				final int numOfReferencesToSearch = 8;
				for (int i = 0;i < numOfReferencesToSearch;i++)
				{
					String data = (String)hash.get("Reference"+i);
					if (data == null) continue;
					
					references.setDataAt(data,i);
				}
		
				/*if (event.equals("OnChoiceSelect") || event.equals("OnAnchorSelect"))
				{
					// Reference0ōČ
					String choice_sentence = selectStringAtRandom(dictionary.getSentenceBlock((String)hash.get("Reference0")));
					if (choice_sentence != null)
					{
						return generateResponce200(choice_sentence,hash);
					}
				}
				else if (event.equals("OnSecondChange"))
				{
					return secondChanged(hash);
				}
				else
				{
					String senentece = selectStringAtRandom(getSentenceBlockWithRedirectingRecursively(event));
					if (senentece != null)
					{
						return generateResponce200(senentece,hash);
					}
				}*/
				
				Vector sentence_block = getSentenceBlockWithRedirectingRecursively(event);
				if (sentence_block != null)
				{
					String senentece = selectStringAtRandom(sentence_block);
					if (senentece != null)
					{
						int talkcount_save = talkCount; // generateResponce200ZbgĂ܂̂ŕۑB
						
						String responce = generateResponce200(senentece,hash);
						if (event.equals("OnSecondChange"))
						{
							// Sentence:\r\n܂ł𔲂oA̒0x7f̕ĂȂsecondChangedsB
							// {͂ƌɔ肷ׂAʓ|B
							int pos_sentence = responce.indexOf("Sentence:");
							int pos_crlf = responce.indexOf("\r\n",pos_sentence);
							boolean is_empty = true;
							//System.out.println(responce.substring(pos_sentence,pos_crlf));
							for (int i = pos_sentence;i < pos_crlf;i++)
							{
								char c = responce.charAt(i);
								if (c > (char)0x7f)
								{
									is_empty = false;
									break;
								}
							}
							//System.out.println((is_empty ? "empty" : "not empty")+" "+System.currentTimeMillis());
							
							if (is_empty)
							{
								talkCount = talkcount_save; // talkCount߂
								return secondChanged(hash);
							}
							else
							{
								return responce;
							}
						}
						else
						{
							return responce;
						}
					}
				}
				else if (event.equals("OnChoiceSelect") || event.equals("OnAnchorSelect"))
				{
					// Reference0ōČ
					String choice_sentence = selectStringAtRandom(dictionary.getSentenceBlock((String)hash.get("Reference0")));
					if (choice_sentence != null)
					{
						return generateResponce200(choice_sentence,hash);
					}
				}
				else if (event.equals("OnSecondChange"))
				{
					return secondChanged(hash);
				}
				
				return "SHIORI/2.0 204 No Content\r\n\r\n";
			}
			else if (hash.get("Sentence") != null) // ZeXt
			{
				// ${Sender}u${Sentence}v̌`ŃbZ[W쐬āAvZeXIԁB
				// uCOMMUNICATEYvIсA204Ԃ܂B
				String sender = (String)hash.get("Sender");
				if (sender.equals("User")) sender = ZENKAKU_USER;
				
				String message = sender+ZENKAKU_KAGIKAKKO_OPEN+(String)hash.get("Sentence")+ZENKAKU_KAGIKAKKO_CLOSE;
				String sentenceToReturn = dictionary.getSentenceMatchesTo(message);
				if (sentenceToReturn != null)
				{
					return generateResponce200(sentenceToReturn,hash);
				}
				
				String sentence = selectStringAtRandom(dictionary.getSentenceBlock(ZENKAKU_COMMNUCATE_NO_MATCHES));
				if (sentence != null)
				{
					return generateResponce200(sentence,hash);
				}
				
				return "SHIORI/2.0 204 No Content\r\n\r\n";
			}
			else // CxgZeX
			{
				String sentenceToReturn = getSentenceBlockOfRandomTalk();
				return (sentenceToReturn == null ? "SHIORI/2.0 204 No Content\r\n\r\n" : generateResponce200(sentenceToReturn,hash));
			}
		}
		else if (header.startsWith("GET String"))
		{
			String string = selectStringAtRandom(dictionary.getWordList((String)hash.get("ID")));
			
			if (string == null)
			{
				return "SHIORI/2.0 204 No Content\r\n\r\n";
			}
			else
			{
				//return "SHIORI/2.5 200 OK\r\nString: " + evaluator.evaluateParenthesis(string) + "\r\n\r\n";
				return "SHIORI/2.5 200 OK\r\nString: " + string + "\r\n\r\n";
			}
		}
		else if (header.startsWith("TEACH"))
		{
			/*
				ϐu***WHAT_TO_LEARN***v݂Ȃ204ԂďIB
			݂΂̒lL[AWord:lƂĕϐɕۑB
			ϐu***WHAT_TO_LEARN***v폜AGgu[L[]ĂvĂяoB
			*/
			if (!variable.exists("***WHAT_TO_LEARN***"))
			{
				return "SHIORI/2.0 204 No Content\r\n\r\n";
			}
			String key = variable.get("***WHAT_TO_LEARN***");
			String word = (String)hash.get("Word");
			variable.put(key,word);
			variable.remove("***WHAT_TO_LEARN***");
			
			String sentence = selectStringAtRandom(dictionary.getSentenceBlock(key + ZENKAKU_TEACHED));
			if (sentence != null)
			{
				return generateResponce200(sentence,hash);
			}
			else
			{
				return "SHIORI/2.0 204 No Content\r\n\r\n";
			}
		}
		else if (header.startsWith("GET Word"))
		{
			return "SHIORI/2.0 204 No Content\r\n\r\n";
		}
		else if (header.startsWith("NOTIFY OwnerGhostName"))
		{
			ownerGhostName = (String)hash.get("Ghost");
			return "SHIORI/2.0 204 No Content\r\n\r\n";
		}
		else
		{
			return "SHIORI/2.0 500 Internal Server Error\r\n\r\n";
		}
    }
    
    private String generateResponce200(String sentence,Hashtable requestTable)
    {
		// requestTable̓S[XgԃR~jP[g邽߁B
		boolean communicate;
		String target = null;
		if (sentence.length() == 0)
		{
			return "SHIORI/2.0 204 No Content\r\n\r\n";
		}
		else if (sentence.charAt(0) == ZENKAKU_RIGHT_ARROW)
		{
			communicate = true;
			// LFOɑSpR݂āAƁF̊Ԃ̕1ȏ̒Ăꍇ́AƁF̊Ԃ͈̔͂ΏۃS[XgƂB
			/*int colon_pos = sentence.indexOf(ZENKAKU_COLON);
			int lf_pos = sentence.indexOf('\n');
			if (colon_pos != -1 && (lf_pos == -1 || colon_pos < lf_pos))
			{
			target = sentence.substring(1,colon_pos);
			if (target.length() == 0) target = null;
			sentence = evaluator.evaluate(sentence.substring(colon_pos));
			}
			else
			{*/
			sentence = evaluator.evaluate(sentence.substring(1));
			//}
		}
		else
		{
			communicate = false;
			sentence = evaluator.evaluate(sentence);
		}
		sentence = post_translator.translate(sentence);
		sentence = decodeEscapedChars(sentence); // fR[h
		
		if (sentence.length() == 0)
		{
			return "SHIORI/2.0 204 No Content\r\n\r\n";
		}
		else
		{
			talkCount = 0; // 200ԂxɃg[NJE^̓ZbgB
		}
		
		if (requestTable.get("Age") != null) // Age
		{
			if (!communicate) // tĂȂ̂ŏI
			{
				return "SHIORI/2.0 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
			}
			else
			{
				// 
				try
				{
					int oldAge = Integer.parseInt( (String)requestTable.get("Age") );
					
					StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
					resp.append("Sender: "+ownerGhostName+"\r\n");
					resp.append("To: "+(target == null ? (String)requestTable.get("Sender") : target)+"\r\n");
					resp.append("Age: "+Integer.toString(oldAge+1)+"\r\n");
					resp.append("Sentence: "+sentence+"\r\n");
					resp.append("\r\n"); // X|XB
					return resp.toString();
				}
				catch (Exception e)
				{
					return "SHIORI/2.3 400 Bad Request\r\n\r\n";
				}
			}
		}
		else // Age
		{
			if (communicate && otherGhostNames.size() > 0) // VɃS[XgԃR~jP[VJnBotherGhostNames̍0IB
			{
				StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
				resp.append("Sender: "+ownerGhostName+"\r\n");
				resp.append("To: "+(target == null ? ((String[])otherGhostNames.elementAt(0))[0] : target)+"\r\n");
				resp.append("Age: 0\r\n");
				resp.append("Sentence: "+sentence+"\r\n");
				resp.append("\r\n"); // X|X
				return resp.toString();
			}
			else
			{
				return "SHIORI/2.0 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
			}
		}
    }
}
